#include "../PrimitiveDecl.h"
#include "../domain-decls.h"
#include "CtPointInstance.h"
#include "CtRegistry.h"
#include <iostream>
#include <cassert>


CtPointInstance::CtPointInstance( unsigned arity )
  : CtInstance( *PointNDecl[ arity - 1 ] ),
    arity( arity )
{
}


void CtPointInstance::dependFields( CtRegistry &registry ) const
{
  registry.add( PrimitiveDecl::IntDecl.cType() );
}


bool CtPointInstance::defineFields( ostream &out ) const
{
#if USE_64BIT_POINTS 
  const CtType &cLong = PrimitiveDecl::LongDecl.cType();
  for (unsigned dimension = 0; dimension < arity; ++dimension)
    out << cLong << ' ' << 'x' << dimension << ";\n";
#else
  const CtType &cInt = PrimitiveDecl::IntDecl.cType();
  for (unsigned dimension = 0; dimension < arity; ++dimension)
    out << cInt << ' ' << 'x' << dimension << ";\n";
#endif

  assert( arity );
  return true;
}


// Local Variables:
// c-file-style: "gnu"
// End:
