#include <iostream>
#include "AST.h"		// ick
#include "CodeContext.h"
#include "code-fence.h"
#include "optimize.h"


const char *fencePreRead()
{
  return sequential_consistency ? "FENCE_PRE_READ();" : "";
}


const char *fencePostWrite()
{
  return sequential_consistency ? "FENCE_POST_WRITE();" : "";
}


const char *TypeNode::fencePreRead() const
{
  return sharing() == Nonshared ? "" : ::fencePreRead();
}


const char *TypeNode::fencePostWrite() const
{
  return sharing() == Nonshared ? "" : ::fencePostWrite();
}


////////////////////////////////////////////////////////////////////////


static ostream &codeLine( ostream &out, const char *code )
{
  if (*code) out << code << endCline;
  return out;
}


ostream &fencePreRead( ostream &out )
{
  return codeLine( out, fencePreRead() );
}


ostream &fencePostWrite( ostream &out )
{
  return codeLine( out, fencePostWrite() );
}


ostream &TypeNode::fencePreRead( ostream &out ) const
{
  return codeLine( out, fencePreRead() );
}


ostream &TypeNode::fencePostWrite( ostream &out ) const
{
  return codeLine( out, fencePostWrite() );
}
