typedef union {
    SimpTerminalInfo SimpTerminal;  	/* Terminal symbols with only position. */
    TerminalInfo Terminal;		/* Terminal symbols with ASCII string data. */
    StrTerminalInfo StrTerminal;	/* Terminal symbols with Unicode string data. */
    CharTerminalInfo CharTerminal;	/* Terminal symbols with Unicode char data. */
    long Int;				/* Simple integer values */
    bool Bool;
    CompileUnitNode* CompileUnit;
    TreeNode* Tree;
    TypeNode* Type;
    CatchNode* Catch;
    llist<TreeNode*>* TreeList;
    llist<TypeNode*>* TypeList;
    llist<CatchNode*>* CatchList;
    Common::Modifiers Modifiers;
    llist<DeclaratorTuple>* DeclaratorList;
    TryNode *Try;
    TypeDeclNode *TypeDecl;
} YYSTYPE;
#define	ABSTRACT	257
#define	BOOLEAN	258
#define	BREAK	259
#define	BROADCAST	260
#define	BYTE	261
#define	CASE	262
#define	CATCH	263
#define	CHAR	264
#define	CLASS	265
#define	CONTINUE	266
#define	DEFAULT	267
#define	DO	268
#define	DOUBLE	269
#define	_DOMAIN	270
#define	ELSE	271
#define	EXTENDS	272
#define	FINAL	273
#define	FINALLY	274
#define	FLOAT	275
#define	FOR	276
#define	FROM	277
#define	FOREACH	278
#define	IF	279
#define	IMPLEMENTS	280
#define	IMPORT	281
#define	INSTANCEOF	282
#define	INT	283
#define	INTERFACE	284
#define	IMMUTABLE	285
#define	IN	286
#define	INLINE	287
#define	LOCAL	288
#define	LONG	289
#define	NATIVE	290
#define	NEW	291
#define	_NULL	292
#define	OPERATOR	293
#define	OVERLAP	294
#define	_PACKAGE	295
#define	PRIVATE	296
#define	PROTECTED	297
#define	PUBLIC	298
#define	POLYSHARED	299
#define	NONSHARED	300
#define	PARTITION	301
#define	POINT	302
#define	RECTDOMAIN	303
#define	RETURN	304
#define	SHORT	305
#define	STATIC	306
#define	SUPER	307
#define	SWITCH	308
#define	SYNCHRONIZED	309
#define	SINGLE	310
#define	SGLOBAL	311
#define	TEMPLATE	312
#define	THIS	313
#define	THROW	314
#define	THROWS	315
#define	TRANSIENT	316
#define	TRY	317
#define	VOID	318
#define	VOLATILE	319
#define	WHILE	320
#define	TRUE	321
#define	FALSE	322
#define	IDENTIFIER	323
#define	INT_LITERAL	324
#define	LONG_LITERAL	325
#define	FLOAT_LITERAL	326
#define	DOUBLE_LITERAL	327
#define	CHARACTER_LITERAL	328
#define	STRING_LITERAL	329
#define	CAND	330
#define	COR	331
#define	EQ	332
#define	NE	333
#define	LE	334
#define	GE	335
#define	LSHIFTL	336
#define	ASHIFTR	337
#define	LSHIFTR	338
#define	PLUS_ASG	339
#define	MINUS_ASG	340
#define	MULT_ASG	341
#define	DIV_ASG	342
#define	REM_ASG	343
#define	LSHIFTL_ASG	344
#define	ASHIFTR_ASG	345
#define	LSHIFTR_ASG	346
#define	AND_ASG	347
#define	XOR_ASG	348
#define	OR_ASG	349
#define	PLUSPLUS	350
#define	MINUSMINUS	351
#define	GUARDS	352


extern YYSTYPE yylval;
