#include <AST.h>
#include "EnactContext.h"


bool TypeNode::enactType( const EnactContext &context )
{
  return isInferable() && context.enactBits( *this, _modifiers, true );
}


////////////////////////////////////////////////////////////////////////


bool ArrayTypeNode::enactType( const EnactContext &context )
{
  bool changed = TypeNode::enactType( context );
  changed |= elementType()->enactType( context );
  return changed;
}


bool TypeListNode::enactType( const EnactContext &context )
{
  bool changed = false;
  foriter (type, allTypes(), TypeIter)
    changed |= (*type)->enactType( context );
  return changed;
}
