#ifndef _include_deref_h_
#define _include_deref_h_

#include <gp-trace/gp-trace.h>
#include <tic.h>

#ifdef WIDE_POINTERS
#define DEREF_GLOBAL_jboolean(val, ptr)           val = (jboolean)__b_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_jbyte(val, ptr)              val = (jbyte)__b_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_jchar(val, ptr)              val = (jchar)__sh_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_jdouble(val, ptr)            val = __d_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_jfloat(val, ptr)             val = __f_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_jint(val, ptr)               val = __i_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_jlong(val, ptr)              val = __l_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_void(val, ptr)               val = __b_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_jshort(val, ptr)             val = __sh_read(CAST_GPTR(ptr))
#define DEREF_GLOBAL_lp(val, ptr)                 *(void **)(&(val)) = __lp_read(CAST_GPTR(ptr))

#define DEREF_GLOBAL_gp(val, ptr)                 *(jGPointer *)(&(val)) = __gp_read(CAST_GPTR(ptr))

#define DEREF_GLOBAL_bulk(val, gptr)              bulk_read(&val, CAST_GPTR(gptr), sizeof(val), tic_has_ptrs) 

#define DEREF_GLOBAL_anonymous_bulk(val, length, gptr) \
   bulk_read((void *)val, CAST_GPTR(gptr), sizeof(*val) * length, tic_has_ptrs) 

#define WEAK_DEREF_GLOBAL_jboolean(val, ptr)      __b_get((jbyte *)&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_jbyte(val, ptr)         __b_get((jbyte *)&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_jchar(val, ptr)         __sh_get((jchar *)&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_jdouble(val, ptr)       __d_get(&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_jfloat(val, ptr)        __f_get(&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_jint(val, ptr)          __i_get(&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_jlong(val, ptr)         __l_get(&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_void(val, ptr)          __b_get(&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_jshort(val, ptr)        __sh_get(&val, CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_lp(val, ptr)            __lp_get(&val, CAST_GPTR(ptr))

#define WEAK_DEREF_GLOBAL_gp(val, ptr)            __gp_get(&CAST_GPTR(val), CAST_GPTR(ptr))
#define WEAK_DEREF_GLOBAL_bulk(val, gptr)         bulk_get(&val, CAST_GPTR(gptr), sizeof(val), tic_has_ptrs) 

#define WEAK_DEREF_GLOBAL_anonymous_bulk(val, length, gptr) \
        bulk_get((void *)val, CAST_GPTR(gptr), sizeof(*val) * length, tic_has_ptrs) 
#endif /* WIDE_POINTERS */

#endif /* !_include_deref_h_ */
