/* see copyright.txt for usage terms */

#ifndef __BARRIER_H__
#define __BARRIER_H__

extern void __barrier_incr_handler(void *token, int val);
extern __tic_lock_t Barrier_mutex;

extern void barrier_init(void);
extern void barrier_up(void);
extern void barrier_down(void);

#ifdef COMM_AM2
#define barrier() do { barrier_up(); barrier_down(); } while (0)
#else /* smp only needs one */
#define barrier() barrier_up()
#endif

/* A barrier of just the threads on this box (used for initialization) */
void local_barrier();

#endif

