#ifndef _include_assign_h_
#define _include_assign_h_

#include <gp-trace/gp-trace.h>
#include <tic.h>

#ifdef WIDE_POINTERS
#define ASSIGN_GLOBAL_jboolean(ptr, val)               __b_write(CAST_GPTR(ptr), (jbyte)val)
#define ASSIGN_GLOBAL_jbyte(ptr, val)                  __b_write(CAST_GPTR(ptr), (jbyte)val)
#define ASSIGN_GLOBAL_jchar(ptr, val)                  __sh_write(CAST_GPTR(ptr), val)
#define ASSIGN_GLOBAL_jdouble(ptr, val)                __d_write(CAST_GPTR(ptr), val)
#define ASSIGN_GLOBAL_jfloat(ptr, val)                 __f_write(CAST_GPTR(ptr), val)
#define ASSIGN_GLOBAL_jint(ptr, val)                   __i_write(CAST_GPTR(ptr), val)
#define ASSIGN_GLOBAL_jlong(ptr, val)                  __l_write(CAST_GPTR(ptr), val)
#define ASSIGN_GLOBAL_void(ptr, val)                   __b_write(CAST_GPTR(ptr), (jbyte)val)
#define ASSIGN_GLOBAL_jshort(ptr, val)                 __sh_write(CAST_GPTR(ptr), val)

#define ASSIGN_GLOBAL_lp(ptr, val)                     __lp_write(CAST_GPTR(ptr), (void *)(val))
#define ASSIGN_GLOBAL_gp(ptr, val)                     __gp_write(CAST_GPTR(ptr), CAST_GPTR(val))
#define ASSIGN_GLOBAL_bulk(gptr, val)                  bulk_write(CAST_GPTR(gptr), &val, sizeof(val)) 

#define ASSIGN_GLOBAL_anonymous_bulk(gptr, length, val)  \
                bulk_write(CAST_GPTR(gptr), (void *)val, sizeof(*val) * length) 

#define WEAK_ASSIGN_GLOBAL_jboolean(ptr, val)          __b_put(CAST_GPTR(ptr), (jbyte)val)
#define WEAK_ASSIGN_GLOBAL_jbyte(ptr, val)             __b_put(CAST_GPTR(ptr), (jbyte)val)
#define WEAK_ASSIGN_GLOBAL_jchar(ptr, val)             __sh_put(CAST_GPTR(ptr), val)
#define WEAK_ASSIGN_GLOBAL_jdouble(ptr, val)           __d_put(CAST_GPTR(ptr), val)
#define WEAK_ASSIGN_GLOBAL_jfloat(ptr, val)            __f_put(CAST_GPTR(ptr), val)
#define WEAK_ASSIGN_GLOBAL_jint(ptr, val)              __i_put(CAST_GPTR(ptr), val)
#define WEAK_ASSIGN_GLOBAL_jlong(ptr, val)             __l_put(CAST_GPTR(ptr), val)
#define WEAK_ASSIGN_GLOBAL_void(ptr, val)              __b_put(CAST_GPTR(ptr), (jbyte)val)
#define WEAK_ASSIGN_GLOBAL_jshort(ptr, val)            __sh_put(CAST_GPTR(ptr), val)

#define WEAK_ASSIGN_GLOBAL_lp(ptr, val)                __lp_put(CAST_GPTR(ptr), (void *)(val))
#define WEAK_ASSIGN_GLOBAL_gp(ptr, val)                __gp_put(CAST_GPTR(ptr), CAST_GPTR(val))
#define WEAK_ASSIGN_GLOBAL_bulk(gptr, val)             bulk_put(CAST_GPTR(gptr), &val, sizeof(val)) 

#define WEAK_ASSIGN_GLOBAL_anonymous_bulk(gptr, length, val)  \
            bulk_put(CAST_GPTR(gptr), (void *)val, sizeof(*val) * length) 
#endif /* WIDE_POINTERS */


#endif /* !_include_assign_h_ */
