/* handlers.h - Definitions for AM handlers */
/* see copyright.txt for usage terms */

#ifndef __HANDLERS_H__
#define __HANDLERS_H__

#include <tic.h>

#define __ERROR_H				0

/* Handlers defined in memory.c */
#define __B_GET_H				1
#define __SH_GET_H				2
#define __I_GET_H				3
#define __F_GET_H				4
#define __D_GET_H				5
#define __L_GET_H				6
#define __LP_GET_H				7
#define __GP_GET_H                              8

#define __B_GET_RH				9
#define __SH_GET_RH				10
#define __I_GET_RH				11
#define __F_GET_RH				12
#define __D_GET_RH				13
#define __L_GET_RH				14
#define __LP_GET_RH				15
#define __GP_GET_RH                             16

#define __B_PUT_H				17
#define __SH_PUT_H				18
#define __I_PUT_H				19
#define __F_PUT_H				20
#define __D_PUT_H		                21
#define __L_PUT_H		                22
#define __LP_PUT_H		                23
#define __GP_PUT_H                              24

#define __DECR_CTR_RH			        25
#define __DECR_PUT_CTR_RH		        26


/* Defined in bulk.c */
#define __GETCOMPLETE_RH		27
#define __BULK_PUT_H			28
#define __PUTCTRCOMPSRC_RH		29
#define __NULL_RH				30
#define __BULK_STORE_H				31


/* Defined in store.c */
#define __B_STORE_H			 	32
#define __SH_STORE_H		 	33
#define __I_STORE_H			 	34
#define __F_STORE_H			 	35
#define __D_STORE_H			 	36
#define __L_STORE_H			37
#define __LP_STORE_H			38
#define __GP_STORE_H                    39

/* Defined in barrier.c */
#define __BARRIER_INCR_H		40

#define __GET_H					41

/* Defined in monitor.c */
#define __MON_ENTER_H    42
#define __MON_ENTER_RH   43
#define __MON_EXIT_H     44
#define __MON_EXIT_RH    45
#define __MON_WAIT_H     46
#define __MON_WAIT_RH    47
#define __MON_SIGNAL_H   48
#define __MON_SIGNAL_RH  49
#define __MON_NOTIFY_H   50
#define __MON_NOTIFY_RH  51
#define __MON_NOTIFY_ALL_H 52
#define __MON_CANCEL_WAIT_H 53

/* for AMUDP statistical collection feature */
#define __AMSTATS_H 54

/* Must update this if add handlers */
#define __LAST_HANDLER			55

#ifdef COMM_AM2
typedef struct handler_function_T {
	handler_t 	handler_index;
	void 		(*func)();
} handler_func_t;

extern handler_func_t handler_list[];
extern handler_func_t reply_handler_list[];
#endif /* COMM_AM2 */

#endif
	
