#ifndef _INCLUDE_FENCE_H_
#define _INCLUDE_FENCE_H_

#if defined(SEQUENTIAL_CONSISTENCY) && defined(MEMORY_SHARED)

# if defined(__GNUC__)
#  define fence_asm(code) __asm__ __volatile__ (code : : : "memory")
# elif defined(__SUNPRO_C)
#  define fence_asm(code) asm(code)
# else
#  error "don't know how to inject inline assembly using this compiler"
# endif/* compiler */

# if #cpu(i386)
#  define FENCE_PRE_READ() fence_asm("lock; addl $0,0(%%esp)")
#  define FENCE_POST_WRITE() fence_asm("")
# elif #cpu(sparc)
#  define FENCE_PRE_READ() fence_asm("")
#  define FENCE_POST_WRITE() fence_asm("fence #StoreLoad")
# else
#  error "don't know how to enforce memory ordering on this architecture"
# endif /* cpu */

#else /* not sequentially consistent shared memory */

# define FENCE_PRE_READ()
# define FENCE_POST_WRITE()

#endif /* not sequentially consistent shared memory */

#endif /* !_INCLUDE_FENCE_H_ */
