static unsigned long /* single */ PERPROC_DEF(nextSharedId);


void m7barriermT2Ti4lang2ti(void);


#ifndef BACKEND_UNIPROC
#define MAXSREGIONS 1024
Region PERPROC_DEF(__sregionidmap[MAXSREGIONS >> 1]);
#endif


struct T12SharedRegion4lang2ti *newsregion(void)
{
  struct T6Region4lang2ti *r = newregion();
  struct T12SharedRegion4lang2ti *sr = (struct T12SharedRegion4lang2ti *)r;
  int id;


  m12SharedRegionmT12SharedRegion4lang2ti(sr);
  PERPROC_REF(nextSharedId) += 2;
  id = PERPROC_REF(nextSharedId) + 1;
#ifndef BACKEND_UNIPROC
  {
    /* Find a free id */
    int firstid = id;


    for (;;)
      {
        id = id % MAXSREGIONS;
        if (id == 1) id = 3;  /* 1 is GC stuff, skip it */

        if (!PERPROC_REF(__sregionidmap[id >> 1]))
          break; /* found a free one */


        id += 2;


        if (id == firstid)
          {
            fprintf(stderr, "More than %d simultaneous shared regions - aborting\n",
                    MAXSREGIONS >> 1 - 1);
            fflush(stderr);
            abort();
          }
      }


    PERPROC_REF(__sregionidmap[id >> 1]) = (Region)r;
  }
#endif


  r->id = id;
  initregion(r);
  /* Synchronise to ensure that all procs have created the region
     before any proc returns (otherwise races are possible where
     one process sees objects in a not-yet-created-locally
     shared region) */
  m7barriermT2Ti4lang2ti();


  return sr;
}


void m6deletemT12SharedRegion4lang2ti(PT12SharedRegion4lang2ti me)
{
  /* Make sure we get the local representative of the region */
  Region r = MyGRegion(*(GRegion*)&me);
#ifndef BACKEND_UNIPROC
  int id = r->id;
#endif


  /* Don't start freeing memory before everyone gets here */
  m7barriermT2Ti4lang2ti();


#ifdef BACKEND_UNIPROC
  if (r->rc)
    abort(); /* Should throw exception */
#endif


  deleteregion(r);


#ifndef BACKEND_UNIPROC
  /* Region id available again */
  FILE_STATIC_STATIC_REF(__sregionidmap[id >> 1]) = NULL;
#endif
}
