#include <stdlib.h>
#include <signal.h>
#include "native-stubs.h"

void free_resources ();
void printExitStats(int sglobal);

void m12exitInternalImT7Runtime4lang4java(PT7Runtime4lang4java me,
						 jint status)
{

#ifdef MEMORY_SHARED
  /* need to prevent more than one thread at a time from running this */
  static __tic_lock_t exit_lock = __tic_lock_decl_initializer;
  __tic_lock(&exit_lock);
#endif

#ifdef COMM_AM2
__tic_lock(&AM_lock);  /* make sure all pending AM ops are complete */
#endif

  printExitStats(0); /* not sglobal because we're not guaranteed that all boxes call this */

#if defined(COMM_AMUDP) 
  if (usingAMSPMD) {
    AMUDP_SPMDExit(status);
  } else 
#elif defined(COMM_AMMPI)
  if (usingAMSPMD) {
    AMMPI_SPMDExit(status);
  } else 
#endif
  free_resources();

#ifdef GLUNIX
  /* Glunix needs this to prevent orphaned processes */
  Glib_Signal(Glib_GetMyNpid(), VNN_ALL, SIGTERM);
#endif

  exit(status);

  abort(); /* we should never reach here */
}
     
void m2gcmT7Runtime4lang4java(PT7Runtime4lang4java me) {
#ifdef USE_GC_NONE
  return;
#else
  if (!GC_dont_gc) { /* if user disabled from environmentu using TI_NOGC, then System.gc() is ignored */
    GC_gcollect();
  }
#endif
}

#ifdef USE_GC_NONE
  unimplemented(m10freeMemorymT7Runtime4lang4java,jlong,(PT7Runtime4lang4java me))
  unimplemented(m11totalMemorymT7Runtime4lang4java,jlong,(PT7Runtime4lang4java me))
#else
jlong m10freeMemorymT7Runtime4lang4java(PT7Runtime4lang4java me) {
  return ti_gc_freeheapsize(); 
}

jlong m11totalMemorymT7Runtime4lang4java(PT7Runtime4lang4java me) {
  return ti_gc_totalheapsize();
}
#endif

unimplemented(m12buildLibNamePT6String4lang4javaPT6String4lang4javamT7Runtime4lang4java,PT6String4lang4java,(PT7Runtime4lang4java me, PT6String4lang4java pathname, PT6String4lang4java filename))
unimplemented(m24initializeLinkerInternalmT7Runtime4lang4java,PT6String4lang4java,(PT7Runtime4lang4java me))
unimplemented(m16loadFileInternalPT6String4lang4javamT7Runtime4lang4java,jboolean,(PT7Runtime4lang4java me, PT6String4lang4java filename))
unimplemented(m15runFinalizationmT7Runtime4lang4java,void,(PT7Runtime4lang4java me))
unimplemented(m17traceInstructionsZmT7Runtime4lang4java,void,(PT7Runtime4lang4java me, jboolean on))
unimplemented(m16traceMethodCallsZmT7Runtime4lang4java,void,(PT7Runtime4lang4java me, jboolean on))
