
// DO NOT EDIT THIS FILE - it is automatically generated from
//  fake template: runtime/domains/tiArrayN.java
// To make changes, edit the source template and follow the README instructions 
//  in that dir to regenerate this file

// Uses fake templates.  Script replaces 2 with specified.

package ti.domains;

//
// ===========
// Grid Arrays
// ===========
//
// This is an array mapped onto a RectDomain.  Indicies into the
// array are Points.
//

class tiArray2 {

  public tiArray2(tiRectDomain2 rd) {
    rect = rd;
    data = new Object[rd.getNumPoints()];
    sideFactors = new tiPoint2();

    // Calculate and cache the "side factors".  These are used in
    // converting a point to an array index and helping in permuting.
    int sf = 1;
    for (int i = 0; i < rd.getArity(); i++) {
      sideFactors.setThis(i, sf);
      sf = sf * rect.getNumSidePoints(i);
    }
  }
  public tiArray2() { }

  private int convertPointToIndex(tiPoint2 p) {
    return p.sub(rect.getLowerBound()).div(rect.getLoopingStride()).dot(sideFactors);
  }

  public tiArray2 set(tiPoint2 p, Object obj) {
    // assert rect.contains(p);
    data[convertPointToIndex(p)] = obj;
    return this;
  }

  public Object get(tiPoint2 p) {
    // assert rect.contains(p);
    return data[convertPointToIndex(p)];
  }

  public tiRectDomain2 getDomain() {
    return rect;
  }

  public int getArity() {
    return rect.getArity();
  }

  public tiArray2 copy(tiArray2 ga) {
    if (rect.isEqual(ga.rect)) {
      int num_points = rect.getNumPoints();
      for (int i = 0; i < num_points; i++) {
	data[i] = ga.data[i];
      }
      sideFactors = ga.sideFactors;
    } else {
      System.out.print("Error: unimplemented.");
      // tiRectDomain2 id;
      // id = rect.multiply(ga.rect);
      // for each p in id {
      //   set(p, ga.get(p));
      // }
    }

    return this;
  }

  public tiArray2 transpose(tiPoint2 p) {
    tiArray2 ga = new tiArray2();

    ga.rect = rect.permute(p);
    ga.data = data;
    ga.sideFactors = sideFactors.permute(p);
    return ga;
  }

  public tiArray2 translate(tiPoint2 p) {
    tiArray2 ga = new tiArray2();

    ga.rect = rect.translate(p);
    ga.data = data;
    ga.sideFactors = sideFactors;
    return ga;
  }

  public tiArray2 inject(tiPoint2 p) {
    tiArray2 ga = new tiArray2();

    ga.rect = rect.inject(p);
    ga.data = data;
    ga.sideFactors = sideFactors;
    return ga;
  }

  public tiArray2 project(tiPoint2 p) {
    tiArray2 ga = new tiArray2();

    ga.rect = rect.project(p);
    ga.data = data;
    ga.sideFactors = sideFactors;
    return ga;
  }

  // State
  private tiRectDomain2 rect;
  private Object data[];
  private tiPoint2 sideFactors;
}
